﻿Imports System.Drawing

Public Class frmShowColor
	Public cName As String
	Dim flag As Boolean
	Dim k1, k2, p1, p2 As Short
	Dim c As Color
	Dim n, s() As String

	'Color.FromArgb(255,251,214)
	'Color.FromKnownColor(Color.Green)
	'&HE8FFEE
	'RGB(0,192,0)

	Private Sub frmShowColor_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) _
		Handles MyBase.Load
		My.Computer.Clipboard.Clear()
		Label1.Select()
	End Sub

	Private Function getColorFromCode(ByVal t As String) As Color
		k1 = t.IndexOf("(")
		k2 = t.IndexOf(")")
		p1 = t.IndexOf(".")
		p2 = t.IndexOf("&H")
		If p1 > 0 And k1 < 0 And k2 < 0 Then	 'Color.Color
			n = t.Substring(p1 + 1)
			c = Color.FromName(n)
		ElseIf k1 > 0 And k2 > 0 Then
			n = t.Substring(p1 + 1, k1 - p1 - 1)
			Select Case n
				Case "FromArgb", "RGB"					'Color.FromArgb
					n = t.Substring(k1 + 1, k2 - k1 - 1)
					s = Split(n, ",")
					For i As Short = 0 To s.Length - 1
						s(i) = CDbl(s(i))
					Next
					If s.Length > 3 Then			 'mit Alphakanal
						c = Color.FromArgb(s(0), s(1), s(2), s(3))
					ElseIf s.Length = 3 Then	 'ohne Alphakanal
						c = Color.FromArgb(s(0), s(1), s(2))
					End If
					cName = IsKnownColorName(c)
				Case "FromKnownColor"
					n = t.Substring(k1 + 1, k2 - k1 - 1)
					n = n.Substring(n.IndexOf(".") + 1)
					c = Color.FromName(n)
					cName = n
			End Select
		ElseIf p2 >= 0 Then
			n = t.Substring(2)
			c = HEXtoColor(n)
		End If
		Return c
	End Function

	Private Function IsKnownColorName(ByVal c As Color) As String
		IsKnownColorName = ""
		Dim arColors As KnownColor() = [Enum].GetValues(GetType(KnownColor))
		Dim colorTable As New Hashtable(arColors.Length)
		For Each kc As KnownColor In arColors
			If Not colorTable.ContainsKey(Color.FromKnownColor(kc).ToArgb) Then
				colorTable.Add(Color.FromKnownColor(kc).ToArgb, kc.ToString)
			End If
		Next
		If colorTable.ContainsKey(c.ToArgb) Then IsKnownColorName = colorTable(c.ToArgb).ToString
	End Function

	Private Sub Button1_Click(sender As Object, e As EventArgs) Handles _
		Button1.Click
		With newColor
			.Text = origColor.Text
			.BackColor = origColor.BackColor
			.ForeColor = GegenFarbe_sw(.BackColor)
		End With
	End Sub

	Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
		Handles Button2.Click
		With origColor
			.BackColor = getColorFromCode(My.Computer.Clipboard.GetText)
			.ForeColor = GegenFarbe_sw(.BackColor)
			.Text = My.Computer.Clipboard.GetText + vbCrLf + cName
			.SelectionStart = 0
		End With
		With newColor
			.Text = origColor.Text
			.BackColor = origColor.BackColor
			.ForeColor = GegenFarbe_sw(.BackColor)
		End With
	End Sub

	Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) _
		Handles CheckBox1.CheckedChanged
		flag = CheckBox1.Checked
		If flag Then CheckBox1.Text = "dunkler" Else CheckBox1.Text = "heller"
	End Sub

	Private Sub NumericUpDown1_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) _
		Handles NumericUpDown1.ValueChanged
		With newColor
			.BackColor = setColorBrightness(origColor.BackColor, NumericUpDown1.Value, flag)
			.ForeColor = GegenFarbe_sw(.BackColor)
			.Text = .BackColor.R.ToString + ", " + .BackColor.G.ToString + ", " + .BackColor.B.ToString _
				+ vbCrLf + ColorToHEX(.BackColor, "&H")
		End With
	End Sub

	' Funktionen
	''' <summary>
	''' Klare Textfarbe (S/W) bei variabler Hintergrundfarbe
	''' </summary>
	''' <param name="farbe">Backgroundfarbe</param>
	''' <returns>Foregroundfarbe schwarz oder weiß</returns>
	Private Function GegenFarbe_sw(ByVal farbe As Color) As Color
		Dim R As Integer = farbe.R	' Farb-Anteile
		Dim G As Integer = farbe.G
		Dim B As Integer = farbe.B
		R = R * 2 : G = G * 5 : B = B
		If R + G + B > 1024 Then
			Return Color.Black	  ' schwarz, weil sehr hell
		Else
			Return Color.White	  ' weiss, weil sehr dunkel
		End If
	End Function

	''' <summary>
	''' Helligkeit einer Farbe ändern
	''' </summary>
	''' <param name="theColor">die aufzuhellende Farbe</param>
	''' <param name="fraction">Faktor der Helligkeitsveränderung 0...255</param>
	''' <param name="decrease">wenn True-> Farbe wird dunkler, sonst heller (default)</param>
	''' <returns>neue Farbe</returns>
	Private Function setColorBrightness(ByVal theColor As Color, ByVal fraction As Integer, _
		Optional ByVal decrease As Boolean = False) As Color
		Dim r, g, b As Integer
		Dim br As Single = theColor.GetBrightness
		Dim n As String = theColor.Name
		Dim c As Long = ColorTranslator.ToWin32(theColor)

		r = 0 : g = 0 : b = 0
		If fraction <= 0 Or fraction > 255 Then fraction = 0
		Try
			' Get the source pixel's color components
			' *** Zerlegen in die Farb-Anteile **************
			b = Int(c / (256 ^ 2))					' Vorkommen höchste Potenz...
			c = c - (b * (256 ^ 2))					' Vorkommen höchste Potenz wegnehmen
			g = Int(c / 256)							' Vorkommen neue höchste Potenz...
			c = c - (g * 256)							' Vorkommen höchste Potenz wegnehmen
			r = Int(c)									' Vorkommen kleinste Potenz (Rest)...
			If decrease Then
				' Decrease the brightness
				r = r - fraction : g = g - fraction : b = b - fraction
				If r < 0 Then r = 0
				If g < 0 Then g = 0
				If b < 0 Then b = 0
			Else
				' Increase the brightness
				r = r + fraction : g = g + fraction : b = b + fraction
				If r > 255 Then r = 255
				If g > 255 Then g = 255
				If b > 255 Then b = 255
			End If
		Catch ex As Exception
		End Try
		' Write the new pixels
		Return Color.FromArgb(r, g, b)
	End Function

	''' <summary>
	''' Konvertieren von .Net Color in Hexadezimal-Farbcode
	''' </summary>
	''' <param name="theColor">die .Net Farbe</param>
	''' <param name="prefix">ein Präfix für den Hex-Farbcode</param>
	''' <returns>HexColor</returns>
	Private Function ColorToHEX(ByVal theColor As Color, Optional ByVal prefix As String = "#") As String
		Return RGBtoHEX(theColor.R, theColor.G, theColor.B, prefix)
	End Function

	''' <summary>
	''' Konvertieren von RGB-Color in Hexadezimal-Farbcode
	''' </summary>
	''' <param name="r">der Rot-Wert</param>
	''' <param name="g">der Grün-Wert</param>
	''' <param name="b">der Blau-Wert</param>
	''' <param name="prefix">ein Präfix für den Hex-Farbcode</param>
	''' <returns>HexColor-String</returns>
	Private Function RGBtoHEX(ByVal r As Integer, ByVal g As Integer, ByVal b As Integer, _
		Optional ByVal prefix As String = "#") As String
		Return String.Format(prefix + "{0:x2}{1:x2}{2:x2}", r, g, b).ToUpper
	End Function

	''' <summary>
	''' Konvertierung von Hexcolor in eine .Net Color
	''' </summary>
	''' <param name="hexColor">der HexCode</param>
	''' <returns>.Net Color</returns>
	Public Function HEXtoColor(ByVal hexColor As String, Optional ByVal prefix As String = "&h") As Color
		If hexColor Is String.Empty Then Return Color.Empty
		hexColor = hexColor.Trim
		If hexColor.Chars(0) = "#" Then hexColor = hexColor.Substring(1)
		If hexColor.Length < 6 Then hexColor = "000000".Substring(0, 6 - hexColor.Length) + hexColor
		Return Color.FromArgb(CInt(prefix + hexColor.Substring(0, 2)), _
		CInt(prefix + hexColor.Substring(2, 2)), _
		CInt(prefix + hexColor.Substring(4, 2)))
	End Function

End Class
